<html>
   <head>
      <meta http-equiv="pragma" content="no-cache">
      <meta http-equiv='content-type' content='text/html; charset=utf-8'>
      %invoke wia.demo.issprofiler.ui.util:getStyleMetadata%
      <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
      <link rel="stylesheet" type="text/css" href="/WiaServiceProfiler/issprofiler.css">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/wrightia.css">
      <script type="text/javascript" src="%value WmRoot/jsFilename%"></script>
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dsp.js"></script>
      %end invoke%
      <style>
         li p { margin-top: 2px; margin-bottom: 4px; }
      </style>
   </head>

   <body style="border: 0;">
      <table width="100%"> <!-- this table is being used only to set a left identation to the child tables -->
         <tr>
            <td width="10">&nbsp;</td>
            <td>
               <table width="95%">
                  <tr>
                     %ifvar text%
                     <td class="heading">"%value text%" use case description</td>
                     %else%
                     <td class="heading">General instructions</td>
                     %endifvar%
                  </tr>

                  %ifvar text%
                  <tr>
                     <td>
                        <table width="100%">
                           <tr>
                              <td class="columnHeading" colspan="2">Test services namespaces</td>
                           </tr>
                           %ifvar srvName%
                           <tr>
                              <script type="text/javascript">
                              writeTag_TD  ( "Run once", "row-l", false );
                              writeTag_TD  ( "%value srvPath%:%value srvName%", "rowdata-l", false );
                              </script>
                           </tr>
                           %endifvar%
                           %ifvar loopSrvName%
                           <tr>
                              <script type="text/javascript">
                              writeTag_TD  ( "Run in loop", "row-l", false );
                              writeTag_TD  ( "%value srvPath%:%value loopSrvName%", "rowdata-l", false );
                              </script>
                           </tr>
                           %endifvar%
                        </table>
                     </td>
                  </tr>
                  %endifvar%

                  <tr>
                     %switch text%
                        %case 'Two Levels'%
                        <td>
                           <p>
                              This service demonstrates the use of a second tier of services.
                           </p>
                           <p>
                              The slowest the performance chosen the more times the second tier of
                              services is invoked.
                           </p>
                           <p>
                              When a low performance test is run you can get preliminary profiling data
                              from the 'Browse Running Services' option on the Profiler's Dashboard.
                              You will be able to identify:
                           </p>
                           <ul>
                              <li>The test service's invocation tree;</li>
                              <li>Statistics on completed executions for each of the tree nodes;</li>
                              <li>Which services are currently running;</li>
                              <li>Statistics on the currently running nodes.</li>
                           </ul>
                        </td>

                        %case 'Single Service'%
                        <td>
                           <p>
                              Single service that executes the <code>addint</code> flow repeatedly.
                           </p>
                           <p>
                              The slowest the performance chosen the more times the <code>addint</code> flow
                              service is executed.
                           </p>
                           <p>
                              This use case shows how a high number of repeated invocations of child services
                              can lead to a service being considered 'slow' although:
                           </p>
                           <ul>
                              <li>All child services show small average execution time;</li>
                              <li>The service's average processing time is large;</li>
                              <li>The service's own code represents only a small part of the processing time taken.</li>
                           </ul>
                           <p>
                              The Profiler's 'View Per Service' Dashboard provides you with cumulative and
                              average performance indicators.
                           </p>
                        </td>

                        %case 'Sorting Arrays'%
                        <td>
                           <p>
                              This service performs some operations with arrays of strings.<br/>
                              The service performs the following duties:
                           </p>
                           <ul>
                              <li>Create an array of randomly generated strings;</li>
                              <li>Sort the string array;</li>
                              <li>Creates an array of string length values based on the string array;</li>
                              <li>Finally sort the string length array using numeric sorting algorithm.</li>
                           </ul>
                           <p>
                              The slowest the performance chosen the more elements will be generated on the
                              string array.
                           </p>
                           <p>
                              This use case shows how a top-level service could be easily pointed out as the
                              culprit of a performance issue when in fact its child services are taking most
                              of the processing time.
                           </p>
                           <p>
                              Comparing the top-level service's 'Own Code' and 'With Child Code' you can
                              quickly realize that it is not taking much time of its own.
                           </p>
                           <p>
                              Using the Profiler's 'Browse Snapshot' feature you can drilldown the service's
                              invocation tree and identify which services are in fact responsible for the
                              performance issue.
                           </p>
                        </td>

                        %case 'File Reader'%
                        <td>
                           <p>
                              This service simulates a file reading operation, and how slow IO can affect
                              the overall performance.
                              The slowest the performance chosen the more time it will take for the file to
                              be read.
                           </p>
                           <p>
                              This use case shows how a service can be identified as culprit of performance
                              issues although it is in fact waiting for IO.
                           </p>
                           <p>
                              You can identify this situation from the Profiler's data observing the following
                              usage pattern:
                           </p>
                           <ul>
                              <li> The top-level service presents low own code 'Elapsed' and 'Spent' times
                                 <p>
                                   This means that only a few amount of time is actually taken by the service's
                                   specific code.
                                 </p>
                              </li>
                              <li> The top-level service presents high child code 'Elapsed' time but low child code 'Spent' time
                                 <p>
                                   This means that the most time is spent on one or many of its child services,
                                   but already hints that CPU time is not being occupied.
                                 </p>
                              </li>
                              <li> The file reader service shows a high 'Elapsed' time and low 'Spent' time
                                 <p>
                                   This means that the file reader service is actually not doing much of
                                   processing work, but instead is waiting for external resources - in this
                                   case disk IO.
                                 </p>
                              </li>
                           </ul>
                           <p>
                              Comparing the top-level service's 'Own Code' and 'With Child Code' you can
                              quickly realize that it is not taking much time of its own.
                           </p>
                           <p>
                              Using the Profiler's 'Browse Snapshot' feature you can drilldown the service's
                              invocation tree and identify the file reader service that is in fact responsible
                              for the performance issue.
                           </p>
                        </td>
                        %case%
                        <td>
                           <p>
                              This panel presents the several options for running pre-defined test services to
                              demonstrate the functionality of the <a HREF="/WiaServiceProfiler" target="_blank">Service Profiler</a>
                              package.
                           </p>
                           <p>
                              The included test services are arranged in Use Cases, and for each you can:
                           </p>
                           <ul>
                              <li> Set the target performance
                                 <p>
                                   This defines for how long one single instance of the Use Case is
                                   kept running.<br/>
                                   The slow down of the test services is achieved either
                                   through <code>sleep</code> instructions in the code, or through an
                                   increase of the number of invocations on child services.
                                 </p>
                              </li>
                              <li> Define if the Use Case runs in an internal loop
                                 <p>
                                   When chosen to run in a loop the Use Case is executed repeatedly until it is
                                   commanded to stop (choose action 'Stop' and then execute).
                                 </p>
                                 <p>
                                   Please attent that when the 'Stop' action is executed any running
                                   Use Case instance will run to completion.
                                 </p>
                              </li>
                              <li> Run the use case
                                 <p>
                                   By pressing the 'Play' button you will be starting a new instance of the
                                   chosen Use Case.
                                 </p>
                                 <p>
                                   The Use Case is run on a separate thread and you can hit the 'Play'
                                   several times to simulate parallel execution of the Use Case.
                                 </p>
                                 <p>
                                   However, the maximum number of simultaneous running threads for each
                                   Use Case is <b>limited to 10</b>.
                                 </p>
                              </li>
                              <li> Check how many Use Case instances are running
                                 <p>
                                   The 'Instances' column displays how many instances of each Use Case are
                                   currently running.
                                 </p>
                              </li>
                           </ul>
                        </td>

                     %endswitch%
                  </tr>
               </table>
            </td>
         </tr>
      </table>

   </body>
</html>
